function [c,r2,yCalc] = fourierfit(xData,yData,order)
%FOURIERFIT Summary of this function goes here
%   Detailed explanation goes here
  n = length(xData);
  X = [1+zeros(n,1)];
  for j=1:order
    X = [X sin(j*pi*xData) cos(j*pi*xData)];
  end
  [c] = regress(yData,X);
  SSE = 0;  
  ymean = mean(yData);
  SStot = sum((yData - ymean).^2);
  yCalc = zeros(n,1);
  for i=1:n
    yCalc(i) = c(1);
    k = 2;
    for j=1:order
      yCalc(i) = yCalc(i) + c(k)*sin(j*pi*xData(i)) + ...
                            c(k+1)*cos(j*pi*xData(i));
      k = k + 2;
    end
    SSE = SSE + (yCalc(i) - yData(i))^2;
  end
  r2 = 1 - SSE / SStot;
end

