function SSE = quantShammasFourierPoly(pwr)
  global xData yData yCalc glbRsqr QSPcoeff
  n = length(xData);
  order = length(pwr);
  X = [1+zeros(n,1)];
  for j=1:2:order
    X = [X sin(pwr(j)*pi*xData) cos(pwr(j+1)*pi*xData)];
  end
  [QSPcoeff] = regress(yData,X);
  SSE = 0;  
  ymean = mean(yData);
  SStot = sum((yData - ymean).^2);
  yCalc = zeros(n,1);
  for i=1:n
    yCalc(i) = QSPcoeff(1);
    for j=2:2:order
      yCalc(i) = yCalc(i) + QSPcoeff(j)*sin(pwr(j-1)*pi*xData(i)) + ...
                            QSPcoeff(j+1)*cos(pwr(j)*pi*xData(i));
    end
    SSE = SSE + (yCalc(i) - yData(i))^2;
  end
  glbRsqr = 1 - SSE / SStot;
end